/*
 * Java
 *
 * Copyright 2015-2020 IS2T. All rights reserved.
 * IS2T PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */
package com.is2t.kf;

import ej.kf.AlreadyLoadedFeatureException;
import ej.kf.IncompatibleFeatureException;
import ej.kf.Kernel;

public interface IKernelFeatureLoader {

	/**
	 * @see KernelNatives#loadFeatureByIndex(long, int)
	 * @return the vm descriptor or <code>-1</code> on error
	 */
	public long loadFeatureByIndex(long featuresHeaderStart, int index);

	/**
	 * @see KernelNatives#canLoadDynamicFeature()
	 */
	public boolean canLoadDynamicFeature();

	/**
	 * @see Kernel#checkLoadedFeature(byte[], byte[], boolean)
	 */
	public boolean checkLoadedFeature(byte[] expectedKernelSignature, byte[] signature,
			boolean expectedKernelEndianness) throws AlreadyLoadedFeatureException, IncompatibleFeatureException;
}
