/*
 * Java
 *
 * Copyright 2015-2021 IS2T. All rights reserved.
 * IS2T PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */
package com.is2t.kf;

import java.io.IOException;
import java.io.InputStream;

import ej.kf.AlreadyLoadedFeatureException;
import ej.kf.Feature;
import ej.kf.IncompatibleFeatureException;
import ej.kf.InvalidFormatException;

/**
 * Default loader that does nothing for statically installed features 
 * (these features cannot be loaded dynamically, and cannot be unloaded).
 */
public class InstalledFeatureLoader implements IFeatureLoader {

	@Override
	public boolean canLoad(byte[] signature) {
		return false;
	}

	@Override
	public boolean canUnload() {
		return false;
	}

	@Override
	public Feature load(IKernelFeatureLoader kernelLoader, byte[] signature,
			InputStream is) throws IOException, InvalidFormatException,
			IncompatibleFeatureException, AlreadyLoadedFeatureException {
		throw new AssertionError();
	}

	@Override
	public boolean unload(Feature f) {
		return false;
	}

}
