/*
 * Java
 *
 * Copyright 2021 MicroEJ Corp. All rights reserved.
 * MicroEJ Corp. PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */
package com.is2t.s3.io;

import java.io.IOException;
import java.io.InputStream;

/**
 * InputStream returned by {@link Class#getResourceAsStream(String)}.
 */
public class ResourceInputStream extends InputStream {

	private final int handle;
	
	public ResourceInputStream(int handle) {
		this.handle = handle;
	}
	
	@Override
	public int available() {
		return availableResource(this.handle);
	}
	
	@Override
	public int read() throws IOException {
		return readResource(this.handle);
	}
	
	@Override
	public void close() {
		closeResource(this.handle);
	}
	
	native static private int availableResource(int handle);
	
	native static private int readResource(int handle);
	
	native static private void closeResource(int hande);
}
