/**
 * Java
 *
 * Copyright 2011-2013 IS2T. All rights reserved
 * IS2T PROPRIETARY/CONFIDENTIAL Use is subject to license terms.
 */
package com.is2t.sp.remote;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;

import ej.ecom.io.Connector;
import ej.ecom.io.StreamConnection;

public class RemoteShieldedPlugConnectorECOM implements RemoteShieldedPlugConnector {

	private static final String CONNECTION_URL_PROPERTY = "sp.connection.url";

	private StreamConnection connection;

	public RemoteShieldedPlugConnectorECOM() {
		String connectionURL = System.getProperty(CONNECTION_URL_PROPERTY);
		if (connectionURL == null) {
			throw new RemoteSPError("Connection URL not defined in property " + CONNECTION_URL_PROPERTY);
		}
		try {
			connection = (StreamConnection) Connector.open(connectionURL);
		} catch (IOException e) {
			throw new RemoteSPError(e.toString());
		}
	}

	public InputStream getInputStream() {
		try {
			return connection.openInputStream();
		} catch (IOException e) {
			throw new RemoteSPError(e.toString());
		}
	}

	public OutputStream getOutputStream() {
		try {
			return connection.openOutputStream();
		} catch (IOException e) {
			throw new RemoteSPError(e.toString());
		}
	}

	public void connect(RequestReader reader) {
		new Thread(reader, "SP Client").start();
	}

}
