/**
 * Java
 *
 * Copyright 2011-2012 IS2T. All rights reserved.
 * IS2T PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */
package com.is2t.sp.remote;

import java.io.DataInputStream;
import java.io.IOException;

import com.is2t.sp.remote.request.SPRequest;

/**
 * Thread that reads request and response from given input stream
 */
public class RequestReader implements Runnable{

	private DataInputStream dis;
	private boolean running;
	private RemoteShieldedPlug requestManager;

	public RequestReader(DataInputStream dis, RemoteShieldedPlug requestPool){
		this.dis = dis;
		this.requestManager = requestPool;
		this.running = true;
	}

	public void run() {
		DataInputStream dis = this.dis;
		RemoteShieldedPlug requestPool = this.requestManager;

		try{
			while(running){
				//read new command
				char requestId = dis.readChar();
				byte cmd = dis.readByte();
				int dataLength = dis.readShort();
				if(cmd < 0){
					//this is a reply
					SPRequest request = requestPool.removeRequest(requestId);
					if(request != null){
						if(SPProtocol.SANITY_CHECK)
							SPRequest.spAssert(request.commandID == -cmd);

						if(dataLength < 0)
							request.exceptionReceived(dataLength);
						else
							request.replyReceived(dis, dataLength);
					}
					else {
						//no request match the reply, skip bytes
						dis.skip(dataLength);
					}
				}
				else {
					//this is a request
					//Client does not manage request
					if(SPProtocol.SANITY_CHECK)
						throw new RemoteSPError();
				}
			}
		}
		catch(IOException e){
		}

	}



}
