/**
 * Java
 *
 * Copyright 2011 IS2T. All rights reserved.
 * IS2T PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */
package com.is2t.sp.remote;

public interface SPProtocol {

	//Request frame :
	//<id(char)> <cmd(byte)> <datalength(short)> <data(datalength)>
	// - id : requestID
	// - cmd : positive
	//
	//Reply frame :
	//<id(16)> <cmd(8)> <dataLength/exception(short)><data(datalength/0)>
	// - id : requestID
	// - cmd : negative (= - request cmd)
	// - dataLength/exception : positive if no exception occured, otherwise exception ID

	//Requests have positive command id, replies have negative command id

	public static boolean SANITY_CHECK = true;
	public static boolean VERBOSE = false;

	public static final int REQ_IsValidDatabaseId	= 1;
	public static final int REQ_IsBigEndian			= 2;
	public static final int REQ_CreateDatabase		= 3;
	public static final int REQ_IsImmutable			= 4;
	public static final int REQ_DeleteBlock			= 5;
	public static final int REQ_GetSize				= 6;
	public static final int REQ_GetIDs				= 7;
	public static final int REQ_GetLength			= 8;
	public static final int REQ_ReadArray			= 9;
	public static final int REQ_ReadInt				= 10;
	public static final int REQ_ReadLong			= 11;
	public static final int REQ_WriteArray			= 12;
	public static final int REQ_WriteInt			= 13;
	public static final int REQ_WriteLong			= 14;
	public static final int REQ_WaitFor				= 15;
	public static final int REQ_IsPending			= 16;
	public static final int REQ_IsDataAvailable		= 17;
	public static final int REQ_Reset				= 18;
	public static final int REQ_CreateBlock			= 19;
	public static final int REQ_GetMaxTasks			= 20;
	public static final int REQ_InterruptRequest	= 21;


	public static final int EXC_SECURITY_EXCEPTION 					= -1;
	public static final int EXC_ILLEGAL_ARGUMENT_EXCEPTION			= -2;
	public static final int EXC_TOO_MANY_WAITING_THREADS_EXCEPTION	= -3;
	public static final int EXC_EMPTY_BLOCK_EXCEPTION				= -4;
	public static final int EXC_INDEX_OUT_OF_BOUNDS_EXCEPTION		= -5;
	public static final int EXC_ARRAY_INDEX_OUT_OF_BOUNDS_EXCEPTION	= -6;

	public static final int BOOLEAN_SIZE	= 1;
	public static final int BYTE_SIZE		= 1;
	public static final int INT_SIZE		= 4;
	public static final int LONG_SIZE		= 8;

}
