/**
 * Java
 *
 * Copyright 2011-2015 IS2T. All rights reserved.
 * IS2T PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */
package com.is2t.sp.remote.request;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;

import ej.sp.EmptyBlockException;
import ej.sp.ShieldedPlug;

public class ReqCreateDatabase extends SPRequest {

	//Request : <id(32)>
	//Reply : nothing
	//Throws : IllegalArgumentException, SecurityException
	//Return : void


	public int databaseId;

	public ReqCreateDatabase(int databaseId) {
		super(REQ_CreateDatabase);
		this.databaseId = databaseId;
	}

	protected int computeDataLength() {
		return INT_SIZE;
	}

	public int getReplyDataLength() {
		return 0;
	}

	protected Object computeReplyResult(DataInputStream dis, int dataLength) throws IOException {
		if(SANITY_CHECK)
			spAssert(dataLength == 0);
		return null;
	}

	public void sendRequest(DataOutputStream dos) throws IOException {
		dos.writeInt(databaseId);
	}

	public static SPRequest buildRequestFromStream(DataInputStream dis, int dataLength) throws IOException {
		if(SANITY_CHECK)
			spAssert(dataLength==INT_SIZE);

		return new ReqCreateDatabase(dis.readInt());
	}

	public void execute() throws EmptyBlockException {
		ShieldedPlug.createDatabase(databaseId);
	}

	public void sendReply(DataOutputStream dos) throws IOException {
		//nothing to do
	}

}
