/**
 * Java
 *
 * Copyright 2011-2015 IS2T. All rights reserved.
 * IS2T PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */
package com.is2t.sp.remote.request;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;

import ej.sp.ShieldedPlug;

public class ReqGetMaxTasks extends SPInstanceRequest {

	public int blockId;

	public int maxTasks;

	public ReqGetMaxTasks(ShieldedPlug sp, int blockId) {
		super(sp, REQ_GetMaxTasks);
		this.blockId = blockId;
	}
	public int computeDataLengthIntern() {
		return INT_SIZE;
	}

	public void sendRequestIntern(DataOutputStream dos) throws IOException {
		dos.writeInt(blockId);
	}

	protected Object computeReplyResult(DataInputStream dis, int dataLength) throws IOException {
		if(SANITY_CHECK)
			spAssert(dataLength == INT_SIZE);

		return new Integer(dis.readInt());
	}

	public static SPInstanceRequest buildRequestFromStream(ShieldedPlug sp, DataInputStream dis, int dataLength) throws IOException{
		if(SANITY_CHECK)
			spAssert(dataLength == INT_SIZE);
		return new ReqGetMaxTasks(sp, dis.readInt());
	}

	public void execute() {
		maxTasks = sp.getMaxTasks(blockId);
	}
	public int getReplyDataLength() {
		return INT_SIZE;
	}
	public void sendReply(DataOutputStream dos) throws IOException {
		dos.writeInt(maxTasks);
	}

}
