/**
 * Java
 *
 * Copyright 2011-2015 IS2T. All rights reserved.
 * IS2T PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */
package com.is2t.sp.remote.request;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;

import ej.sp.EmptyBlockException;
import ej.sp.ShieldedPlug;

public class ReqGetSize extends SPInstanceRequest {

	//Request : nothing
	//Reply : <size(int)>
	//Throws : nothing
	//Return : Integer

	public int size;

	public ReqGetSize(ShieldedPlug sp) {
		super(sp, REQ_GetSize);
	}

	public int computeDataLengthIntern() {
		return 0;
	}

	public void sendRequestIntern(DataOutputStream dos) throws IOException {
		//nothing

	}

	protected Object computeReplyResult(DataInputStream dis, int dataLength) throws IOException {
		if(SANITY_CHECK)
			spAssert(dataLength == INT_SIZE);
		return new Integer(dis.readInt());
	}

	public static SPInstanceRequest buildRequestFromStream(ShieldedPlug sp, DataInputStream dis, int dataLength) throws IOException{
		if(SANITY_CHECK)
			spAssert(dataLength == 0);
		return new ReqGetSize(sp);
	}

	public void execute() throws EmptyBlockException {
		size = sp.getSize();
	}

	public int getReplyDataLength() {
		return INT_SIZE;
	}

	public void sendReply(DataOutputStream dos) throws IOException {
		dos.writeInt(size);
	}

}
