/**
 * Java
 *
 * Copyright 2011-2015 IS2T. All rights reserved.
 * IS2T PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */
package com.is2t.sp.remote.request;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;

import ej.sp.EmptyBlockException;
import ej.sp.ShieldedPlug;

public class ReqIsImmutable extends SPInstanceRequest{

	//Request : nothing
	//Reply : <isImmutable(bool)>
	//Throws : nothing
	//Return : Boolean

	public boolean isImmutable;

	public ReqIsImmutable(ShieldedPlug sp) {
		super(sp, REQ_IsImmutable);
	}

	public int computeDataLengthIntern() {
		return 0;
	}

	public void sendRequestIntern(DataOutputStream dos) throws IOException {
		//no parameter
	}

	protected Object computeReplyResult(DataInputStream dis, int dataLength) throws IOException {
		if(SANITY_CHECK)
			spAssert(dataLength == BOOLEAN_SIZE);
		return new Boolean(dis.readBoolean());
	}

	public static SPInstanceRequest buildRequestFromStream(ShieldedPlug sp, DataInputStream dis, int dataLength) throws IOException{
		if(SANITY_CHECK)
			spAssert(dataLength == 0);
		return new ReqIsImmutable(sp);
	}

	public void execute() throws EmptyBlockException {
		isImmutable = sp.isImmutable();
	}

	public int getReplyDataLength() {
		return BOOLEAN_SIZE;
	}

	public void sendReply(DataOutputStream dos) throws IOException {
		dos.writeBoolean(isImmutable);
	}

}
