/**
 * Java
 *
 * Copyright 2011-2015 IS2T. All rights reserved.
 * IS2T PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */
package com.is2t.sp.remote.request;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;

import ej.sp.EmptyBlockException;
import ej.sp.ShieldedPlug;


public class ReqIsValidDatabaseId extends SPRequest {

	//Request : <id(32)>
	//Response : nothing
	//Throws : IllegalArgumentException
	//Return : void

	public int databaseId;

	public ReqIsValidDatabaseId(int databaseId){
		super(REQ_IsValidDatabaseId);
		this.databaseId = databaseId;
	}

	public int computeDataLength() {
		return INT_SIZE;//int size
	}

	public void sendRequest(DataOutputStream dos) throws IOException {
		dos.writeInt(databaseId);
	}

	protected Object computeReplyResult(DataInputStream dis, int dataLength) throws IOException {
		if(SANITY_CHECK)
			spAssert(dataLength == 0);
		return new Object();
	}

	public static SPRequest buildRequestFromStream(DataInputStream dis, int dataLength) throws IOException {
		if(SANITY_CHECK)
			spAssert(dataLength==INT_SIZE);

		return new ReqIsValidDatabaseId(dis.readInt());
	}

	public void execute() throws EmptyBlockException {
		ShieldedPlug.getDatabase(databaseId);
	}

	public int getReplyDataLength() {
		return 0;
	}

	public void sendReply(DataOutputStream dos) throws IOException {
		//nothing to do
	}

}
