
/*
 *	Java
 *	
 *	Copyright 2015 IS2T. All rights reserved.
 *	IS2T PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

/**
 * Java 1.5
 *
 * Copyright 2011 IS2T. All rights reserved
 * IS2T PROPRIETARY/CONFIDENTIAL Use is subject to license terms.
 */
package com.is2t.sp.remote.request;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;

import ej.sp.EmptyBlockException;
import ej.sp.ShieldedPlug;

public class ReqReadLong extends SPInstanceRequest {

	//Request : <blockID(int)>
	//Response : <data(long)>
	//Throws : IllegalArgumentException, EmptyBlockException, IndexOutOfBoundsException
	//Return : Long
	
	public int blockID;
	
	public long value;
	
	public ReqReadLong(ShieldedPlug sp, int blockID) {
		super(sp, REQ_ReadLong);
		this.blockID = blockID;
	}
	
	public int computeDataLengthIntern() {
		return INT_SIZE;
	}

	public void sendRequestIntern(DataOutputStream dos) throws IOException {
		dos.writeInt(blockID);
	}

	protected Object computeReplyResult(DataInputStream dis, int dataLength) throws IOException {
		if(SANITY_CHECK)
			spAssert(dataLength == LONG_SIZE);

		return new Long(dis.readLong());
	}

	public static SPInstanceRequest buildRequestFromStream(ShieldedPlug sp, DataInputStream dis, int dataLength) throws IOException{
		if(SANITY_CHECK)
			spAssert(dataLength == INT_SIZE);
		return new ReqReadLong(sp, dis.readInt());
	}

	public void execute() throws EmptyBlockException {
		value = sp.readLong(blockID);
	}
	public int getReplyDataLength() {
		return LONG_SIZE;
	}
	public void sendReply(DataOutputStream dos) throws IOException {
		dos.writeLong(value);
	}
}
