
/*
 *	Java
 *	
 *	Copyright 2015 IS2T. All rights reserved.
 *	IS2T PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

/**
 * Java 1.5
 *
 * Copyright 2011 IS2T. All rights reserved
 * IS2T PROPRIETARY/CONFIDENTIAL Use is subject to license terms.
 */
package com.is2t.sp.remote.request;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;

import ej.sp.EmptyBlockException;
import ej.sp.ShieldedPlug;

public class ReqWriteLong extends SPInstanceRequest {

	//Request : <blockID(int)> <value(long)>
	//Response : nothing
	//Throws : IllegalArgumentException, IndexOutOfBoundsException
	//Return : void
	
	public int blockID;
	
	public long value;
	
	public ReqWriteLong(ShieldedPlug sp, int blockID, long value) {
		super(sp, REQ_WriteLong);
		this.blockID = blockID;
		this.value = value;
	}
	
	public int computeDataLengthIntern() {
		return INT_SIZE + LONG_SIZE;
	}

	public void sendRequestIntern(DataOutputStream dos) throws IOException {
		dos.writeInt(blockID);
		dos.writeLong(value);
	}

	protected Object computeReplyResult(DataInputStream dis, int dataLength) throws IOException {
		if(SANITY_CHECK)
			spAssert(dataLength == 0);

		return null;
	}

	public static SPInstanceRequest buildRequestFromStream(ShieldedPlug sp, DataInputStream dis, int dataLength) throws IOException{
		if(SANITY_CHECK)
			spAssert(dataLength == INT_SIZE+LONG_SIZE);
		return new ReqWriteLong(sp, dis.readInt(), dis.readLong());
	}

	public void execute() throws EmptyBlockException {
		sp.writeLong(blockID, value);
	}
	public int getReplyDataLength() {
		return 0;
	}
	public void sendReply(DataOutputStream dos) throws IOException {
		//nothing to do
	}
}
