/*
 * Java
 *
 * Copyright 2018 IS2T. All rights reserved.
 * IS2T PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */
package com.is2t.sp.remote.request;

/**
 * SP request executed asynchronously.
 */
public interface SPAsynchronousRequest {

	/**
	 * Wait for the end of the execution of this request.
	 */
	public void waitForEndOfExecution();

	/**
	 * Set the thread that executes this request
	 * @param requestThread the thread that executes this request.
	 */
	public void setRequestThread(Thread requestThread);

	/**
	 * Returns the thread that executes this request.
	 */
	public Thread getRequestThread();

}
