
/*
 *	Java
 *	
 *	Copyright 2011-2015 IS2T. All rights reserved.
 *	IS2T PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

package ej.sp;

public class SimpleIntToObjectTable {

	int[] keys ;
	Object[] values;
	int ptr;

	public SimpleIntToObjectTable() {
		this(5);
	}

	public SimpleIntToObjectTable(int size) {
		//the array where all the keys/values are stored once added
		keys = new int[size];
		values = new Object[size];
		ptr = -1;
	}

	public Object at(int key) {
		//null is returned for notFound value
		int[] keys = this.keys;
		for(int i = ptr + 1; --i >= 0; ) {
			if(key == keys[i]) {
				return values[i];
			}
		}
		return null;
	}

	public void atPut(int key, Object value) {
		//search if key already exists
		if(at(key) == null) {
			//the key hasn't been found: creates a new one.
			atPutAlreadyCheckNotExists(key, value);
		}
	}

	public void atPutAlreadyCheckNotExists(int key, Object value) {
		//creates a new key.
		try {
			keys[++ptr] = key;
		}
		catch(ArrayIndexOutOfBoundsException ex) {
			System.arraycopy(keys, 0, keys = new int[ptr<<1], 0, ptr);
			System.arraycopy(values, 0, values = new Object[ptr<<1], 0, ptr);
			keys[ptr] = key;
		}
		values[ptr] = value;
	}


}
