@rem BATCH
@rem
@rem Copyright 2020 MicroEJ Corp. All rights reserved.
@rem This library is provided in source code for use, modification and test, subject to license terms.
@rem Any modification of the source code will break MicroEJ Corp. warranties on the whole library.

@ECHO OFF

rem log file name
set logfile="launcher-windows.log"

rem check if java command exists 
java -version 2> %logfile%

IF /I "%ERRORLEVEL%" NEQ "0" (
	echo =========================================
	echo =========================================
	echo Cannot found the java command.
	echo Please install it.
	echo =========================================
	echo =========================================
	pause
	exit
)

echo MicroEJ Virtual Device is being launched. Relax and enjoy
echo:

SET ANT_HOME=%cd%\ant
java -cp ant\lib\ant-1.9.9.jar;ant\lib\ant-junit-1.8.4.jar;ant\lib\ant-launcher-1.9.9.jar org.apache.tools.ant.Main -buildfile s3Standalone.microejLaunch


findstr /L /C:"BUILD FAILED" %logfile% >nul 2>nul
if not errorlevel 1 (
	echo:
	echo Unexpected error while launching the application. Please check the log file for details (%logfile%^).
	pause
)

exit
rem batch script ends here

rem gets size of file given as first argument, in bytes
:getsize
set size=%~z1
exit /B